
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <netdb.h>
#include <unistd.h>
#include <mpi.h>

int main(int argc, char **argv)
{
    int         rank;
    int         size;        /* number of processes in job */
    int         peer;


    MPI_Init(&argc, &argv);
    MPI_Comm_rank(MPI_COMM_WORLD, &rank);
    MPI_Comm_size(MPI_COMM_WORLD, &size);

   
    if (rank%2==1 && rank!=size-1) {
        MPI_Recv(&peer, 1, MPI_INT, rank+1, 0, MPI_COMM_WORLD,MPI_STATUS_IGNORE);
        MPI_Send(&rank, 1, MPI_INT, rank+1, 0, MPI_COMM_WORLD);
        printf("I am %d  and sent to %d\n", rank,(rank+1));

    }
    else if (rank%2==0 && rank!=0) {
        MPI_Recv(&peer, 1, MPI_INT, rank-1, 0, MPI_COMM_WORLD,MPI_STATUS_IGNORE);
        printf("I am %d  and received from %d\n", rank, peer);
        MPI_Send(&rank, 1, MPI_INT, rank-1, 0, MPI_COMM_WORLD);
    }
   

    MPI_Barrier(MPI_COMM_WORLD);
    MPI_Finalize();
    return 0;
}
