/*
 * Copyright (c) 2004-2006 The Trustees of Indiana University and Indiana
 *                         University Research and Technology
 *                         Corporation.  All rights reserved.
 * Copyright (c) 2006      Cisco Systems, Inc.  All rights reserved.
 *
 * Sample MPI "hello world" application in C
 */

#include <stdio.h>
#include "mpi.h"

int main(int argc, char* argv[])
{
    int rank, size;
    int ready = 0;
    MPI_Init(&argc, &argv); //Initialize the MPI execution environment 
    MPI_Comm_rank(MPI_COMM_WORLD, &rank); //Determines the rank of the calling process in the communicator 
    MPI_Comm_size(MPI_COMM_WORLD, &size); //Determines the size of the group associated with a communicator 
    if(rank==0){
    	printf("I'm master and process number is %d\n",rank);
    	printf("This program runs with %d processors\n", size);
        ready=1;
    }
    
    MPI_Bcast(&ready, 1, MPI_INT, 0, MPI_COMM_WORLD);

    if (rank>0){
        printf("Hello, world, I am %d of %d\n", rank, size);
        printf("I am %d and received from master ready as %d\n",rank, ready);
    }
    else{
        MPI_Bcast(&ready, 1, MPI_INT, 0, MPI_COMM_WORLD);
    }

   

    MPI_Barrier(MPI_COMM_WORLD); //Blocks until all processes in the communicator have reached this routine. 
    MPI_Finalize();//Terminates MPI execution environment

    return 0;
}
