#include <stdio.h>
#include "mpi.h"

int main(int argc, char* argv[])
{
    int rank; // rank of the current processor
    int size; // total number of processors

    MPI_Init(&argc, &argv);
    MPI_Comm_rank(MPI_COMM_WORLD, &rank); // gets the rank of the current processor
    MPI_Comm_size(MPI_COMM_WORLD, &size); // gets the total number of processors
    
    int N;
    FILE *cin = fopen(argv[1], "r"); // reads from argument
    fscanf(cin,"%d", &N);
    int arr[N*N+N]; // stores preferences of all
    int pref[N]; // stores preferences of each
    
    // If it's master processor, reads from input file
    if(rank==0){
    	int num=0,j=0,i=N;
    	for(;j<N;j++)
    		arr[j]=0;
    	while(fscanf(cin, "%d", &num)==1){
    		arr[i]=num;
    		i++;
    	}
    	fclose(cin);
 
    }

    // sends data from root array arr to pref array on each processor

    MPI_Scatter(arr,N,MPI_INT,pref,N,MPI_INT,0,MPI_COMM_WORLD);

    

    int masterSignal = 1; 
    while(masterSignal){
        
    	if(rank!= 0){
    		int i = 0;    
            for(; i<N;i++){
                printf("Process Numb %d and %d th element of my list is %d\n",rank,i+1,pref[i] );
            }
    	}
    	    	
    	if(rank==0){
    		masterSignal=0;
    	}

    	MPI_Bcast(&masterSignal, 1, MPI_INT, 0, MPI_COMM_WORLD);

    	
    }

		 
    MPI_Barrier(MPI_COMM_WORLD);
    MPI_Finalize();

    return 0;
}
